(function() {

    return {

        events: {

            // App events

            'app.activated' : 'checkCurrentAgentsGroups',

            // DOM events - below

            'click .toggle-app' : 'toggleAppContainer',
            'click .btn' : 'tagTicketChangeGroup'
        },

        checkCurrentAgentsGroups: function() { // compare group membership of current user to app settings optional parameter group list

            var groupObjects = this.currentUser().groups(); // return array of group objects for current user
            console.log(groupObjects);
            var result = _.map(groupObjects, function(group){ return group.id(); }); // build array of all group id values for current agent from groupObjects
            console.log(result);
            var settings = this.setting('hideForThisGroup').split(","); // split a string value by comma that is equal to all group ids in the app settings into an array of substrings
            console.log(settings);
            var settingsMap = _.map(settings, function(hideThese){ return parseInt(hideThese.trim(), 0);}); // build array of group id integer values from substring array and remove whitespace from both sides of each substring
            console.log(settingsMap);
            // console.log(_.intersection(result, settingsMap));
            var contains = _.intersection(result, settingsMap); // compute the list of values in both arrays where there is any match
            if ( contains.length > 0) { // expression is checking if "contains" has values, if it does that means the current user is not supposed to see the app
                console.log('Unauthorized user');
                this.switchTo('hide');
            } else {
                console.log('Authorized user');
                this.switchTo('show');
            }
        },

        tagTicketChangeGroup: function() {
            var ticket = this.ticket();
            ticket.tags().remove("uber");
            ticket.tags().add("unassign");
            services.notify('Assignee will be reset after submission!!!');
        },

        toggleAppContainer: function() {
            var $container = this.$('.app-container'),
            $icon = this.$('.toggle-app i');

            if ($container.is(':visible')) {
                $container.hide();
                $icon.prop('class', 'icon-plus');
            } else {
                $container.show();
                $icon.prop('class', 'icon-minus');
            }
        }
    };
}());